/*----------------------------------------------------------------------------
 HMG OBJECTS - Harbour GUI library source code

 Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 http://sites.google.com/site/hmgweb/

 Project HMG.4 
 GRID Control Class contributed by: Danny A. del Pilar <dhaine_adp@yahoo.com>
  
 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of HMG.

 The exception is that, if you link the HMG library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 HMG library code into it.

---------------------------------------------------------------------------*/

#include "hbclass.ch"
#include "common.ch"

*..............................................................................*
* Class Frame .................................................................*
*..............................................................................*

CLASS GRID FROM CONTROL

	* Internal Data

	DATA lAllowAppend	INIT .F.
	DATA lAllowDelete	INIT .F.
	DATA lAllowEdit		INIT .F.
	DATA lCellNavigation	INIT .F.
	DATA aColumnControls	INIT Nil
	DATA aColumnFields	INIT Nil
	DATA aColumnValid	INIT Nil
	DATA aColumnWhen	INIT Nil
	DATA aColumnWidths	INIT Nil
	DATA aColumnHeaders	INIT Nil
	DATA aDynamicBackColor	INIT Nil
	DATA aDynamicForeColor	INIT Nil
	DATA aDynamicDisplay	INIT Nil
	DATA aHeaderImages	INIT Nil
	DATA aColumnJustify	INIT Nil
	DATA lLines		INIT .T.
	DATA nLockColumns	INIT Nil
	DATA cRowSource		INIT Nil		// *object property kept for backward compatibility
	DATA lShowHeaders	INIT .T.
	DATA lVirtual		INIT .F.
	DATA bOnHeadClick	INIT Nil
	DATA bOnQueryData	INIT Nil
	DATA bOnSave		INIT Nil
	DATA nModelView		INIT Nil		// *new grid object property, required for Qt Support
                                        // to add intelligence to GRID control, it is supposed to
                                        // be declared as hidden but for the time being assumes exported
	* Properties 

	METHOD AllowAppend	SETGET
	METHOD AllowDelete	SETGET
	METHOD AllowEdit	SETGET
	METHOD CellNavigation	SETGET
	METHOD ColumnControls	SETGET
	METHOD ColumnFields	SETGET
	METHOD ColumnValid	SETGET
	METHOD ColumnWhen	SETGET
	METHOD ColumnWidths	SETGET
	METHOD ColumnHeaders	SETGET
	METHOD DynamicBackColor	SETGET
	METHOD DynamicForeColor	SETGET
	METHOD DynamicDisplay	SETGET
	METHOD HeaderImages	SETGET
	METHOD ColumnJustify	SETGET
	METHOD Lines		SETGET
	METHOD LockColumns	SETGET
	METHOD RowSource	SETGET			// *method kept for backward compatibility
	METHOD ShowHeaders	SETGET
	METHOD Virtual		SETGET
	METHOD RecNo		SETGET
	METHOD Cell		SETGET
	METHOD Item		SETGET
	METHOD Header		SETGET

	* Events

	METHOD OnHeadClick	SETGET
	METHOD OnQueryData	SETGET
	METHOD OnSave		SETGET

	* Methods

	METHOD Create() CONSTRUCTOR 
	METHOD Append()
	METHOD Delete()
	METHOD Recall()
	METHOD AddColumn()
	METHOD DeleteColumn()
	METHOD EnableUpdate()
	METHOD DisableUpdate()
	METHOD Refresh()


ENDCLASS

*..............................................................................*
* Properties ..................................................................*
*..............................................................................*

METHOD AllowAppend ( lValue ) CLASS GRID

	If !::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::lAllowAppend

		ElseIf Pcount() == 1 

			::lAllowAppend := lValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD RecNo ( nValue ) CLASS GRID

	If !::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::nRecNo

		ElseIf Pcount() == 1 

			::nRecNo := nValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD Cell ( nRow , nCol , xValue ) CLASS GRID

RETURN Nil

*..............................................................................*

METHOD Item ( nRow , xValue ) CLASS GRID

RETURN Nil

*..............................................................................*

METHOD Header ( nCol , cValue ) CLASS GRID

RETURN Nil

*..............................................................................*

METHOD AllowDelete ( lValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::lAllowDelete

		ElseIf Pcount() == 1 

			::lAllowDelete := lValue
		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD AllowEdit ( lValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0



		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::lAllowEdit

		ElseIf Pcount() == 1 

			::lAllowEdit := lValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD CellNavigation ( lValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::lCellNavigation

		ElseIf Pcount() == 1 

			::lCellNavigation := lValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD ColumnControls ( aValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::aColumnControls

		ElseIf Pcount() == 1 

			::aColumnControls := aValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD ColumnFields ( aValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::aColumnFields

		ElseIf Pcount() == 1 

			::aColumnFields := aValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD ColumnValid ( aValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::aColumnValid

		ElseIf Pcount() == 1 

			::aColumnValid := aValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD ColumnWhen ( aValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::aColumnWhen

		ElseIf Pcount() == 1 

			::aColumnWhen := aValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD ColumnWidths ( aValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::aColumnWidths

		ElseIf Pcount() == 1 

			::aColumnWidths := aValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD ColumnHeaders ( aValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::aColumnHeaders

		ElseIf Pcount() == 1 

			::aColumnHeaders := aValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD DynamicBackColor ( aValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::aDynamicBackColor

		ElseIf Pcount() == 1 

			::aDynamicBackColor := aValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD DynamicForeColor ( aValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0


		ElseIf Pcount() == 1 


		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::aDynamicForeColor

		ElseIf Pcount() == 1 

			::aDynamicForeColor := aValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD DynamicDisplay ( aValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::aDynamicDisplay

		ElseIf Pcount() == 1 

			::aDynamicDisplay := aValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD HeaderImages ( xParam1 , xParam2 ) CLASS GRID


RETURN Nil

*..............................................................................*

METHOD ColumnJustify ( aValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	
	
		ElseIf Pcount() == 1 


		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::aColumnJustify

		ElseIf Pcount() == 1 

			::aColumnJustify := aValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD Lines ( lValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::lLines

		ElseIf Pcount() == 1 

			::lLines := lValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD LockColumns ( nValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0


		ElseIf Pcount() == 1 


		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::nLockColumns

		ElseIf Pcount() == 1 

			::nLockColumns := nValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD RowSource ( cValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	

		ElseIf Pcount() == 1 


		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::cRowSource

		ElseIf Pcount() == 1 

			::cRowSource := cValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD ShowHeaders ( lValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	

		ElseIf Pcount() == 1 


		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::lShowHeaders

		ElseIf Pcount() == 1 

			::lShowHeaders := lValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD Virtual ( lValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::lVirtual

		ElseIf Pcount() == 1 

			::lVirtual := lValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*
* Events ......................................................................*
*..............................................................................*

METHOD OnHeadClick ( bValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0
	


		ElseIf Pcount() == 1 



		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::bOnHeadClick

		ElseIf Pcount() == 1 

			::bOnHeadClick := bValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD OnQueryData ( bValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0


		ElseIf Pcount() == 1 


		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::bOnQueryData

		ElseIf Pcount() == 1 

			::bOnQueryData := bValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*

METHOD OnSave ( bValue ) CLASS GRID

	If ::lCreated 

	        If Pcount() == 0


		ElseIf Pcount() == 1 


		EndIf

	Else

	        If Pcount() == 0
	
			RETURN ::bOnSave

		ElseIf Pcount() == 1 

			::bOnSave := bValue

		EndIf

	EndIf

RETURN Nil

*..............................................................................*
* Methods .....................................................................*
*..............................................................................*
***************************************************************************************
**   Method Name: Create()                                                           **
**       Purpose: GRID Object control constructor                                    **
**                                                                                   **
**        Syntax: Create( nRow, nCol, aHeads_, nGwidth, nGheight, aItems_ ) --> Self **
**                Grid():Create() --> Self                                           **
**                Grid():Create( nExp1, nExp2, aExp3, nExp4, nExp5, aExp6 ) --> Self **
**                                                                                   **
**     Arguments: nExp1 = Numeric expression that denotes Grid top left row.         **
**                nExp2 = Numeric expression that denotes Grid top left column.      **
**                        This is the grid row, column coordinates in xBase lingo.   **
**                aExp3 = Single dimensional array containing the Grid Horizontal    **
**                        Headers. Vertical Headers can be implemented on the fly    **
**                        once the Grid Control Class is instantiated.               **
**                nExp4 = Numeric expression denoting the Grid's width.              **
**                nExp5 = Numeric expression denoting the Grid's height.             **
**                aExp6 = Array expression that contains the Grid's Items in row and **
**                        column data matrix (e.g. DBF Table). The array can be a    **
**                        single or two dimensions as in the case of GRID aItems in  **
**                        HMG.35 and lower. This should contain alias prefix         **
**                        otherwise the column will be treated as virtual column.    **
**                                                                                   **
**                        When aExp6 is a single dimensional, GRID's behaviour would **
**                        be the HBQT's implementation of HBQTAbstractItemModel,     **
**                        HBQTAbstractItemView or Qt's equivalent to                 **
**                        QSqlRelationalTableModel in HBQT's implementation. This is **
**                        the extension of GRID. I needed to do more research about  **
**                        this one to properly implement with HMG.4 for forward and  **
**                        backward compatibily.                                      **
**                                                                                   **
**                        When aExp6 is two dimensional array, QTableView will be    **
**                        the GRID's object to be instantiated.                      **
**                                                                                   **
**                        When Header contains images, well in TODO list for the     **
**                        time being.                                                **
**                                                                                   **
**                        These are the minimum parameters required to be setup in   **
**                        HMG.35 and lower and thus adopted to HMG.4 to get the      **
**                        GRID control displayed on the screen. (Please correct me   **
**                        if I am wrong in this assumption.)                         **
**                                                                                   **
**       Returns:   Self                                                             **
**                                                                                   **
**         Notes: GRID Candidate Alpha, subject for revision, unstable.   -Danny     **
**                                                                                   **
** TODO LIST:                                                                        **
** - Grid Header Images.                                                             **
** - Grid Joining of Fields from different tables.                                   **
** - Grid Virtual Columns which is not part of any joined table or flat table.       **
** - Grid inline editing.                                                            **
** - Grid Vertical Headers.                                                          **
**                                                                                   **
***************************************************************************************
METHOD Create( nRow, nCol, aHeads_, nGwidth, nGheight, aItems_ ) CLASS GRID

	local cTVar := ""
	local aTemp_
	local ii
	local nJoinedTable := 0
	local nVirtualCol  := 0

	**-> Step #1 check parameters, it is required to be checked so that **
	**           the grid can be activated with no parameters.          **
	**     Note: All parameters is received as local variables.         **
	**********************************************************************
	do case
		** supply the parameters automatically with default values:
		case Pcount() == 0
			nRow     := 0
			nCol     := 0
			aHeads_  := {""}
			nGwidth  := 200
			nGheight := 100
			aItems_  := {{""}}
			
		case Pcount() == 1
			if !valtype( HB_PValue( 1 ) ) == "N"
				** syntax error, hmg GRID Object.ch should contain correct translation
				** no idea yet on how to raise HMG run-time error in HMG.4
			endif
			
			nCol     := 0
			aHeads_  := {""}
			nGwidth  := 200
			nGheight := 100
			aItems_  := {{""}}

		case Pcount() == 2
			if !valtype( HB_PValue( 1 ) ) == "N" .and. !valtype( HB_PValue( 2 ) ) == "N"
				** call HMG run-time error/syntax error
			endif
			aHeads_  := {""}
			nGwidth  := 200
			nGheight := 100
			aItems_  := {{""}}

		case Pcount() == 3
			if !valtype( HB_PValue( 1 ) ) == "N" .and.;
				!valtype( HB_PValue( 2 ) ) == "N" .and.;
				!valtype( HB_PValue( 3 ) ) == "A"
				** call HMG run-time error/syntax error
			endif

		case Pcount() == 4
			if !valtype( HB_PValue( 1 ) ) == "N" .and.;
				!valtype( HB_PValue( 2 ) ) == "N" .and.;
				!valtype( HB_PValue( 3 ) ) == "A" .and. ;
				!valtype( HB_PValue( 4 ) ) == "N" 
				** call HMG run-time error/syntax error
			endif
			nGheight := 100
			aItems_  := {{""}}

		case Pcount() == 5
			if !valtype( HB_PValue( 1 ) ) == "N" .and.  ;
				!valtype( HB_PValue( 2 ) ) == "N" .and. ;
				!valtype( HB_PValue( 3 ) ) == "A" .and. ;
				!valtype( HB_PValue( 4 ) ) == "N" .and. ;
				!valtype( HB_PValue( 5 ) ) == "N" 
				** call HMG run-time error/syntax error
			endif
			aItems_  := {{""}}
		
		case Pcount() == 6	
			if !valtype( HB_PValue( 1 ) ) == "N" .and.  ;
				!valtype( HB_PValue( 2 ) ) == "N" .and. ;
				!valtype( HB_PValue( 3 ) ) == "A" .and. ;
				!valtype( HB_PValue( 4 ) ) == "N" .and. ;
				!valtype( HB_PValue( 5 ) ) == "N" .and. ;
				!valtype( HB_PValue( 6 ) ) == "A"
				** call HMG run-time error/syntax error
			endif
	endcase
	
	**--> Step #2, check out how the grid will be intantiate **
	** Needs to check the element 1 only.                    **
	***********************************************************
	if valtype( aItems_[ 1 ] ) == "A"
		::nModelView := 1    // emulate HMG GRID original behaviour
	else
		** crude implementation of checking table alias prefix symbol
		if at( ">", aItems_[ 1 ] ) > 0
			** find out if grid will be instantiated with joined fields **
			** or flat table and or containing virtual columns          **
			**************************************************************
			aTemp_ := asort( aItems_ )
			cTemp  := ""
			for ii = 1 to len( aItems_ )
				if substr( aItems_[ ii ], 1, ( at( "-", aItems_[ ii ] ) - 1 ) ) == cTemp
					cTemp := substr( aItems_[ ii ], 1, ( at( "-", aItems_[ ii ] ) - 1 ) )
					nJoinedTable++
				endif
				if .not. at( ">", aItems_[ ii ] ) > 0
					nVirtualCol++
				endif
			next
			do case
				case nJoinedTable = 1 .and. nVirtualCol = 0
					nModelView := 2 	// flat table, no virtual col
					
				case nJoinedTable >= 3 .and. nVirtualCol = 0
					nModelView := 3 	// joined table, no virtual col
			otherwise
				nModelView := 4		// flat or joined table with virtual column
			endcase
		endif
	endif

	**-> Step #3, instantiate the GRID Object control **
	****************************************************
	do case
		case nModelView = 1
			::oQTObject := QTableWidget():New( ::oParent:oQTObject )
			
		case nModelView = 2
		case nModelView = 3
		case nModelView = 4
	endcase
	
	**--> Step #4 initialized, grid object properties**
	***************************************************
	::lCreated := .T.
	
	::oParent:AddData ( ::cName , Self )

RETURN Self

*..............................................................................*

METHOD Append() CLASS GRID

	If ::lCreated 

	EndIf
                          
RETURN Self

*..............................................................................*

METHOD Delete() CLASS GRID

	If ::lCreated 

	EndIf
                          
RETURN Self

*..............................................................................*

METHOD Recall() CLASS GRID

	If ::lCreated 

	EndIf
                          
RETURN Self

*..............................................................................*

METHOD AddColumn ( nColIndex , cCaption , nWidth , nJustify ) CLASS GRID

	If ::lCreated 

	EndIf
                          
RETURN Self

*..............................................................................*

METHOD DeleteColumn( nCol ) CLASS GRID

	If ::lCreated 

	EndIf
                          
RETURN Self

*..............................................................................*

METHOD EnableUpdate () CLASS GRID

	If ::lCreated 

	EndIf
                          
RETURN Self

*..............................................................................*

METHOD DisableUpdate () CLASS GRID

	If ::lCreated 

	EndIf
                          
RETURN Self

*..............................................................................*

METHOD Refresh() CLASS GRID

	If ::lCreated 

	EndIf

RETURN Self




